# $Revision: 1.438.2.24 $, $Date: 2012/02/05 13:45:40 $
# TODO
# - gcc4-c++ collides with gcc-c++:
#   %{_libdir}/libsupc++.a
#   %{_libdir}/libsupc++.la
#
# Conditional build:
%bcond_without	ada		# build without ADA support
%bcond_with	profiling	# build with profiling
%bcond_without	bootstrap	# omit 3-stage bootstrap
%bcond_without	cxx		# build without C++ support
%bcond_with	tests		# torture gcc

%if %{without bootstrap}
%undefine	with_profiling
%endif

%define	sname	gcc
Summary:	GNU Compiler Collection: the C compiler and shared files
Summary(es.UTF-8):	Colección de compiladores GNU: el compilador C y ficheros compartidos
Summary(pl.UTF-8):	Kolekcja kompilatorów GNU: kompilator C i pliki współdzielone
Summary(pt_BR.UTF-8):	Coleção dos compiladores GNU: o compilador C e arquivos compartilhados
Name:		%{sname}4
Version:	4.1.2
Release:	10
Epoch:		5
License:	GPL v2+
Group:		Development/Languages
Source0:	ftp://gcc.gnu.org/pub/gcc/releases/gcc-%{version}/%{sname}-%{version}.tar.bz2
# Source0-md5:	a4a3eb15c96030906d8494959eeda23c
Source1:	%{name}-optimize-la.pl
Patch0:		%{name}-info.patch
Patch1:		%{name}-nolocalefiles.patch
Patch2:		%{name}-nodebug.patch
Patch3:		%{name}-ada-link.patch
Patch4:		%{name}-sparc64-ada_fix.patch
Patch5:		%{name}-alpha-ada_fix.patch
# -fvisibility fixes...
Patch6:		%{name}-pr19664_gnu_internal.patch
Patch7:		%{name}-pr19664_libstdc++.patch
Patch8:		%{name}-pr20218.patch

# PRs
Patch10:	%{name}-pr7776.patch
Patch11:	%{name}-pr19606.patch
Patch12:	%{name}-pr24879.patch

Patch16:	gcc-4.1-pr29826.patch
Patch17:	%{name}-pr19505.patch
Patch18:	%{name}-pr24419.patch
Patch19:	%{name}-pr24669.patch
Patch20:	%{name}-pr17390.patch
Patch21:	%{name}-pr13676.patch
Patch22:	%{name}-pr25626.patch
Patch23:	%{name}-libstdcxx-bitset.patch

Patch26:	%{name}-ppc64-m32-m64-multilib-only.patch

# 128-bit long double support for glibc 2.4
Patch30:	%{name}-ldbl-default-libstdc++.patch
Patch31:	%{name}-ldbl-default.patch

# Needed to bootstrap with gcc 4.2
Patch40:	%{name}-ada.patch
URL:		http://gcc.gnu.org/
BuildRequires:	autoconf
%{?with_tests:BuildRequires:	autogen}
BuildRequires:	automake
# binutils 2.16.91 or newer are required for compiling medium model now
BuildRequires:	binutils >= 2:2.16.91.0.1
BuildRequires:	bison
BuildRequires:	chrpath >= 0.10
%{?with_tests:BuildRequires:	dejagnu}
BuildRequires:	fileutils >= 4.0.41
BuildRequires:	flex
%if %{with ada}
BuildRequires:	gcc(ada)
BuildRequires:	gcc-ada
%endif
BuildRequires:	gcc
BuildRequires:	gettext-devel
BuildRequires:	glibc-devel >= 6:2.3
BuildRequires:	gmp-devel
BuildRequires:	perl-base
BuildRequires:	rpmbuild(macros) >= 1.211
BuildRequires:	texinfo >= 4.1
BuildRequires:	zlib-devel
%{?with_ada:Provides:	gcc(ada)}
# AS_NEEDED directive for dynamic linker
# http://sources.redhat.com/ml/glibc-cvs/2005-q1/msg00614.html
# http://sources.redhat.com/ml/binutils/2005-01/msg00288.html
Requires:	binutils >= 2:2.16.90.0.1-0.3
Requires:	libgcc4 = %{epoch}:%{version}-%{release}
Provides:	cpp4 = %{epoch}:%{version}-%{release}
Provides:	gcc = %{epoch}:%{version}-%{release}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_slibdir	/%{_lib}

# TODO: correct these or document
# libstdc++.so.6.0.8 symbol: ___tls_get_addr
%define		skip_post_check_so	libstdc\\+\\+.so.6.0.*

%description
A compiler aimed at integrating all the optimizations and features
necessary for a high-performance and stable development environment.

This package contains the C compiler and some files shared by various
parts of the GNU Compiler Collection. In order to use another GCC
compiler you will need to install the appropriate subpackage.

%description -l es.UTF-8
Un compilador que intenta integrar todas las optimalizaciones y
características necesarias para un entorno de desarrollo eficaz y
estable.

Este paquete contiene el compilador de C y unos ficheros compartidos
por varias partes de la colección de compiladores GNU (GCC). Para usar
otro compilador de GCC será necesario que instale el subpaquete
adecuado.

%description -l pl.UTF-8
Kompilator, posiadający duże możliwości optymalizacyjne niezbędne do
wyprodukowania szybkiego i stabilnego kodu wynikowego.

Ten pakiet zawiera kompilator C i pliki współdzielone przez różne
części kolekcji kompilatorów GNU (GCC). Żeby używać innego kompilatora
z GCC, trzeba zainstalować odpowiedni podpakiet.

%description -l pt_BR.UTF-8
Este pacote adiciona infraestrutura básica e suporte a linguagem C ao
GNU Compiler Collection.

%package -n libgcc4
Summary:	Shared gcc library
Summary(es.UTF-8):	Biblioteca compartida de gcc
Summary(pl.UTF-8):	Biblioteka gcc
Summary(pt_BR.UTF-8):	Biblioteca runtime para o GCC
License:	GPL with unlimited link permission
Group:		Libraries
Provides:	libgcc = %{epoch}:%{version}-%{release}

%description -n libgcc4
Shared gcc library.

%description -n libgcc4 -l es.UTF-8
Biblioteca compartida de gcc.

%description -n libgcc4 -l pl.UTF-8
Biblioteka dynamiczna gcc.

%description -n libgcc4 -l pt_BR.UTF-8
Biblioteca runtime para o GCC.

%package ada
Summary:	Ada support for gcc
Summary(es.UTF-8):	Soporte de Ada para gcc
Summary(pl.UTF-8):	Obsługa Ady do gcc
Group:		Development/Languages
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	libgnat = %{epoch}:%{version}-%{release}
Obsoletes:	gcc-ada < %{epoch}:%{version}-%{release}
Obsoletes:	gcc-gnat
Obsoletes:	gnat-devel

%description ada
This package adds experimental support for compiling Ada programs.

%description ada -l es.UTF-8
Este paquete añade soporte experimental para compilar programas en
Ada.

%description ada -l pl.UTF-8
Ten pakiet dodaje eksperymentalne wsparcie dla kompilacji programów w
Adzie.

%package -n libgnat
Summary:	Ada standard libraries
Summary(es.UTF-8):	Bibliotecas estándares de Ada
Summary(pl.UTF-8):	Biblioteki standardowe dla Ady
License:	GPL v2+ with linking exception
Group:		Libraries
Obsoletes:	gnat
Obsoletes:	libgnat1

%description -n libgnat
This package contains shared libraries needed to run programs written
in Ada.

%description -n libgnat -l es.UTF-8
Este paquete contiene las bibliotecas compartidas necesarias para
ejecutar programas escritos en Ada.

%description -n libgnat -l pl.UTF-8
Ten pakiet zawiera biblioteki potrzebne do uruchamiania programów
napisanych w Adzie.

%package -n libgnat-static
Summary:	Static Ada standard libraries
Summary(pl.UTF-8):	Statyczne biblioteki standardowe dla Ady
License:	GPL v2+ with linking exception
Group:		Development/Libraries
Obsoletes:	gnat-static

%description -n libgnat-static
This package contains static libraries for programs written in Ada.

%description -n libgnat-static -l pl.UTF-8
Ten pakiet zawiera biblioteki statyczne dla programów napisanych w
Adzie.

%package c++
Summary:	C++ support for gcc
Summary(es.UTF-8):	Soporte de C++ para gcc
Summary(pl.UTF-8):	Obsługa C++ dla gcc
Summary(pt_BR.UTF-8):	Suporte C++ para o gcc
Group:		Development/Languages
Requires:	%{name} = %{epoch}:%{version}-%{release}
Provides:	%{name}-c++ = %{epoch}:%{version}-%{release}
Obsoletes:	egcc-c++
Obsoletes:	egcs-c++
Obsoletes:	gcc-c++ < %{epoch}:%{version}-%{release}

%description c++
This package adds C++ support to the GNU Compiler Collection. It
includes support for most of the current C++ specification, including
templates and exception handling. It does not include a standard C++
library, which is available separately.

%description c++ -l de.UTF-8
Dieses Paket enthält die C++-Unterstützung für den
GNU-Compiler-Collection. Es unterstützt die aktuelle
C++-Spezifikation, inkl. Templates und Ausnahmeverarbeitung. Eine
C++-Standard-Library ist nicht enthalten - sie ist getrennt
erhältlich.

%description c++ -l es.UTF-8
Este paquete añade soporte de C++ al GCC (colección de compiladores
GNU). Ello incluye el soporte para la mayoría de la especificación
actual de C++, incluyendo plantillas y manejo de excepciones. No
incluye la biblioteca estándar de C++, la que es disponible separada.

%description c++ -l fr.UTF-8
Ce package ajoute un support C++ a la collection de compilateurs GNU.
Il comprend un support pour la plupart des spécifications actuelles de
C++, dont les modéles et la gestion des exceptions. Il ne comprend pas
une bibliothéque C++ standard, qui est disponible séparément.

%description c++ -l pl.UTF-8
Ten pakiet dodaje obsługę C++ do kompilatora gcc. Ma wsparcie dla
dużej ilości obecnych specyfikacji C++, nie zawiera natomiast
standardowych bibliotek C++, które są w oddzielnym pakiecie.

%description c++ -l pt_BR.UTF-8
Este pacote adiciona suporte C++ para o gcc.

%description c++ -l tr.UTF-8
Bu paket, GNU C derleyicisine C++ desteği ekler. 'Template'ler ve
aykırı durum işleme gibi çoğu güncel C++ tanımlarına uyar. Standart
C++ kitaplığı bu pakette yer almaz.

%package -n libstdc++4
Summary:	GNU C++ library
Summary(es.UTF-8):	Biblioteca C++ de GNU
Summary(pl.UTF-8):	Biblioteki GNU C++
Summary(pt_BR.UTF-8):	Biblioteca C++ GNU
License:	GPL v2+ with free software exception
Group:		Libraries
Provides:	libstdc++ = %{epoch}:%{version}-%{release}
Obsoletes:	libg++
Obsoletes:	libstdc++3

%description -n libstdc++4
This is the GNU implementation of the standard C++ libraries, along
with additional GNU tools. This package includes the shared libraries
necessary to run C++ applications.

%description -n libstdc++4 -l de.UTF-8
Dies ist die GNU-Implementierung der Standard-C++-Libraries mit
weiteren GNU-Tools. Dieses Paket enthält die zum Ausführen von
C++-Anwendungen erforderlichen gemeinsam genutzten Libraries.

%description -n libstdc++4 -l es.UTF-8
Este es el soporte de las bibliotecas padrón del C++, junto con
herramientas GNU adicionales. El paquete incluye las bibliotecas
compartidas necesarias para ejecutar aplicaciones C++.

%description -n libstdc++4 -l fr.UTF-8
Ceci est l'implémentation GNU des librairies C++ standard, ainsi que
des outils GNU supplémentaires. Ce package comprend les librairies
partagées nécessaires à l'exécution d'application C++.

%description -n libstdc++4 -l pl.UTF-8
Pakiet ten zawiera biblioteki będące implementacją standardowych
bibliotek C++. Znajdują się w nim biblioteki dynamiczne niezbędne do
uruchomienia aplikacji napisanych w C++.

%description -n libstdc++4 -l pt_BR.UTF-8
Este pacote é uma implementação da biblioteca padrão C++ v3, um
subconjunto do padrão ISO 14882.

%description -n libstdc++4 -l tr.UTF-8
Bu paket, standart C++ kitaplıklarının GNU gerçeklemesidir ve C++
uygulamalarının koşturulması için gerekli kitaplıkları içerir.

%package -n libstdc++4-devel
Summary:	Header files and documentation for C++ development
Summary(de.UTF-8):	Header-Dateien zur Entwicklung mit C++
Summary(es.UTF-8):	Ficheros de cabecera y documentación para desarrollo C++
Summary(fr.UTF-8):	Fichiers d'en-tête et biblitothèques pour développer en C++
Summary(pl.UTF-8):	Pliki nagłówkowe i dokumentacja do biblioteki standardowej C++
Summary(pt_BR.UTF-8):	Arquivos de inclusão e bibliotecas para o desenvolvimento em C++
Summary(tr.UTF-8):	C++ ile program geliştirmek için gerekli dosyalar
License:	GPL v2+ with free software exception
Group:		Development/Libraries
Requires:	%{name}-c++ = %{epoch}:%{version}-%{release}
Requires:	glibc-devel
Requires:	libstdc++4 = %{epoch}:%{version}-%{release}
Provides:	libstdc++-devel = %{epoch}:%{version}-%{release}
Obsoletes:	libg++-devel
Obsoletes:	libstdc++-devel < %{epoch}:%{version}-%{release}
Obsoletes:	libstdc++3-devel

%description -n libstdc++4-devel
This is the GNU implementation of the standard C++ libraries. This
package includes the header files needed for C++ development and
library documentation.

%description -n libstdc++4-devel -l es.UTF-8
Este es el soporte de las bibliotecas padrón del lenguaje C++. Este
paquete incluye los archivos de inclusión y bibliotecas necesarios
para desarrollo de programas en lenguaje C++.

%description -n libstdc++4-devel -l pl.UTF-8
Pakiet ten zawiera biblioteki będące implementacją standardowych
bibliotek C++. Znajdują się w nim pliki nagłówkowe wykorzystywane przy
programowaniu w języku C++ oraz dokumentacja biblioteki standardowej.

%description -n libstdc++4-devel -l pt_BR.UTF-8
Este pacote inclui os arquivos de inclusão e bibliotecas necessárias
para desenvolvimento de programas C++.

%package -n libstdc++4-static
Summary:	Static C++ standard library
Summary(es.UTF-8):	Biblioteca estándar estática de C++
Summary(pl.UTF-8):	Statyczna biblioteka standardowa C++
License:	GPL v2+ with free software exception
Group:		Development/Libraries
Requires:	libstdc++4-devel = %{epoch}:%{version}-%{release}
Provides:	libstdc++-static = %{epoch}:%{version}-%{release}

%description -n libstdc++4-static
Static C++ standard library.

%description -n libstdc++4-static -l es.UTF-8
Biblioteca estándar estática de C++.

%description -n libstdc++4-static -l pl.UTF-8
Statyczna biblioteka standardowa C++.

%prep
%setup -q -n gcc-%{version}

%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1

# -fvisbility fixes...
%patch6 -p1
%patch7 -p1
%patch8 -p1

# PRs
%patch10 -p1
%patch11 -p0
%patch12 -p0

cd gcc
%patch16 -p0
cd -
%patch17 -p1
%patch18 -p1
%patch19 -p1
%patch20 -p1
%patch21 -p1
%patch22 -p1
%patch23 -p1

%patch26 -p1

%patch30 -p0
%patch31 -p0

%patch40 -p1

# because we distribute modified version of gcc...
sed -i 's:#define VERSUFFIX.*:#define VERSUFFIX " (PLD-Linux)":' gcc/version.c
perl -pi -e 's@(bug_report_url.*<URL:).*";@$1http://bugs.pld-linux.org/>";@' gcc/version.c

mv ChangeLog ChangeLog.general

%build
cd gcc
%{__autoconf}
cd ..
cp -f /usr/share/automake/config.sub .

rm -rf builddir && install -d builddir && cd builddir

CFLAGS="%{rpmcflags}" \
CXXFLAGS="%{rpmcxxflags}" \
TEXCONFIG=false \
../configure \
	--program-suffix="4" \
	--prefix=%{_prefix} \
	--with-local-prefix=%{_prefix}/local \
	--libdir=%{_libdir} \
	--libexecdir=%{_libdir} \
	--infodir=%{_infodir} \
	--mandir=%{_mandir} \
	--x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
	--enable-shared \
	--enable-threads=posix \
	--enable-languages="c%{?with_cxx:,c++}%{?with_ada:,ada}" \
	--enable-c99 \
	--enable-long-long \
	--enable-nls \
	--disable-werror \
	--with-gnu-as \
	--with-gnu-ld \
	--with-demangler-in-ld \
	--with-system-zlib \
	--with-slibdir=%{_slibdir} \
%ifnarch ia64
	--without-system-libunwind \
%else
	--with-system-libunwind \
%endif
	--without-x \
	--disable-multilib \
%if %{with cxx}
	--with-gxx-include-dir=%{_includedir}/c++/%{version} \
	--disable-libstdcxx-pch \
	--enable-__cxa_atexit \
	--enable-libstdcxx-allocator=new \
%endif
	%{_target_platform}

cd ..

%{__make} -C builddir \
	%{?with_bootstrap:%{?with_profiling:profiled}bootstrap} \
	GCJFLAGS="%{rpmcflags}" \
	BOOT_CFLAGS="%{rpmcflags}" \
	STAGE1_CFLAGS="%{rpmcflags} -O0" \
	GNATLIBCFLAGS="%{rpmcflags}" \
	LDFLAGS_FOR_TARGET="%{rpmldflags}" \
	mandir=%{_mandir} \
	infodir=%{_infodir}

%{?with_tests:%{__make} -k -C builddir check 2>&1 ||:}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{/lib,%{_aclocaldir},%{_datadir},%{_infodir}}

cd builddir

%{__make} -j1 install \
	mandir=%{_mandir} \
	infodir=%{_infodir} \
	DESTDIR=$RPM_BUILD_ROOT

install gcc/specs $RPM_BUILD_ROOT%{_libdir}/gcc/%{_target_platform}/%{version}

%ifarch sparc64
ln -sf	%{_bindir}/sparc64-pld-linux-gcc4 \
	$RPM_BUILD_ROOT%{_bindir}/sparc-pld-linux-gcc4
%endif

ln -sf %{_bindir}/cpp4 $RPM_BUILD_ROOT/lib/cpp4
ln -sf gcc4 $RPM_BUILD_ROOT%{_bindir}/cc4
echo ".so gcc4.1" > $RPM_BUILD_ROOT%{_mandir}/man1/cc4.1

mv $RPM_BUILD_ROOT{%{_libdir}/libssp.so.*,%{_slibdir}}
ln -sf %{_slibdir}/$(basename $RPM_BUILD_ROOT%{_slibdir}/libssp.so.*.*.*) $RPM_BUILD_ROOT%{_libdir}/libssp.so
chmod +x $RPM_BUILD_ROOT%{_slibdir}/libgcc_s.so.1
# rename so we could be installed with system gcc.spec
mv $RPM_BUILD_ROOT%{_slibdir}/libgcc_s.so.{1,%{version}}
ln -s libgcc_s.so.%{version} $RPM_BUILD_ROOT%{_slibdir}/libgcc_s.so.1

%if %{with ada}
# move ada shared libraries to proper place...
mv -f	$RPM_BUILD_ROOT%{_libdir}/gcc/*/*/adalib/*.so.1 \
	$RPM_BUILD_ROOT%{_libdir}
# check if symlink to be made is valid
test -f	$RPM_BUILD_ROOT%{_libdir}/libgnat-4.1.so.1
ln -sf	libgnat-4.1.so.1 $RPM_BUILD_ROOT%{_libdir}/libgnat-4.1.so
ln -sf	libgnarl-4.1.so.1 $RPM_BUILD_ROOT%{_libdir}/libgnarl-4.1.so
ln -sf	libgnat-4.1.so $RPM_BUILD_ROOT%{_libdir}/libgnat.so
ln -sf	libgnarl-4.1.so $RPM_BUILD_ROOT%{_libdir}/libgnarl.so
%endif

cd ..

# include/ contains install-tools/include/* and headers that were fixed up
# by fixincludes, we don't want former
gccdir=$(echo $RPM_BUILD_ROOT%{_libdir}/gcc/*/*/)
mkdir	$gccdir/tmp

# we have to save these however
mv $gccdir/include/syslimits.h $gccdir/tmp
mv $gccdir/include/ssp $gccdir/tmp
rm -rf $gccdir/include
mv $gccdir/tmp $gccdir/include
cp $gccdir/install-tools/include/*.h $gccdir/include
# but we don't want anything more from install-tools
rm -rf $gccdir/install-tools

for a in $RPM_BUILD_ROOT%{_datadir}/locale/*/LC_MESSAGES/*.mo; do
	d=${a%/*} # dirname
	n=${a##*/} # basename
	mv $a $d/${n%.mo}4.mo
done

%find_lang gcc4
%find_lang cpplib4
cat cpplib4.lang >> gcc4.lang

%if %{with cxx}
%find_lang libstdc\+\+4
install libstdc++-v3/include/stdc++.h $RPM_BUILD_ROOT%{_includedir}
%endif

# cvs snap doesn't contain (release does) below files,
# so let's create dummy entries to satisfy %%files.
[ ! -f NEWS ] && touch NEWS

# not packaged anywhere
rm -f $RPM_BUILD_ROOT%{_infodir}/dir
rm -f $RPM_BUILD_ROOT%{_infodir}/cpp.info
rm -f $RPM_BUILD_ROOT%{_infodir}/cppinternals.info
rm -f $RPM_BUILD_ROOT%{_infodir}/gcc.info
rm -f $RPM_BUILD_ROOT%{_infodir}/gccinstall.info
rm -f $RPM_BUILD_ROOT%{_infodir}/gccint.info
rm -f $RPM_BUILD_ROOT%{_includedir}/mf-runtime.h
rm -f $RPM_BUILD_ROOT%{_libdir}/libiberty.a
rm -f $RPM_BUILD_ROOT%{_mandir}/man7/fsf-funding.7
rm -f $RPM_BUILD_ROOT%{_mandir}/man7/gfdl.7
rm -f $RPM_BUILD_ROOT%{_mandir}/man7/gpl.7
# don't build these then?
rm -f $RPM_BUILD_ROOT%{_libdir}/libmudflap.a
rm -f $RPM_BUILD_ROOT%{_libdir}/libmudflap.la
rm -f $RPM_BUILD_ROOT%{_libdir}/libmudflap.so
rm -f $RPM_BUILD_ROOT%{_libdir}/libmudflap.so.0
rm -f $RPM_BUILD_ROOT%{_libdir}/libmudflap.so.0.0.0
rm -f $RPM_BUILD_ROOT%{_libdir}/libmudflapth.a
rm -f $RPM_BUILD_ROOT%{_libdir}/libmudflapth.la
rm -f $RPM_BUILD_ROOT%{_libdir}/libmudflapth.so
rm -f $RPM_BUILD_ROOT%{_libdir}/libmudflapth.so.0
rm -f $RPM_BUILD_ROOT%{_libdir}/libmudflapth.so.0.0.0

# remove empty language catalogs (= 1 message only)
find $RPM_BUILD_ROOT%{_datadir}/locale -type f -name '*.mo' | xargs file | grep -E ', 1 messages$' | cut -d: -f1 | xargs rm -vf

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/postshell
-/usr/sbin/fix-info-dir -c %{_infodir}

%postun	-p /sbin/postshell
-/usr/sbin/fix-info-dir -c %{_infodir}

%post	-p /sbin/ldconfig -n libgcc4
%postun	-p /sbin/ldconfig -n libgcc4

%post	-p /sbin/ldconfig -n libstdc++4
%postun	-p /sbin/ldconfig -n libstdc++4

%post ada
[ ! -x /usr/sbin/fix-info-dir ] || /usr/sbin/fix-info-dir -c %{_infodir} >/dev/null 2>&1

%postun ada
[ ! -x /usr/sbin/fix-info-dir ] || /usr/sbin/fix-info-dir -c %{_infodir} >/dev/null 2>&1

%files -f gcc4.lang
%defattr(644,root,root,755)
%doc ChangeLog.general MAINTAINERS NEWS
# bugs.html faq.html
%doc gcc/{ChangeLog,ONEWS,README.Portability}
%dir %{_libdir}/gcc
%dir %{_libdir}/gcc/*
%dir %{_libdir}/gcc/*/*
%dir %{_libdir}/gcc/*/*/include
%dir %{_libdir}/gcc/*/*/include/ssp

%attr(755,root,root) %{_bindir}/*-gcc*
%attr(755,root,root) %{_bindir}/gcc4
%attr(755,root,root) %{_bindir}/gccbug4
%attr(755,root,root) %{_bindir}/gcov4
%attr(755,root,root) %{_bindir}/cc4
%attr(755,root,root) %{_bindir}/cpp4

%{_mandir}/man1/cc4.1*
%{_mandir}/man1/cpp4.1*
%{_mandir}/man1/gcc4.1*
%{_mandir}/man1/gcov4.1*

%attr(755,root,root) /lib/cpp4
%attr(755,root,root) %{_slibdir}/libgcc_s.so
%{_libdir}/libssp.a
%{_libdir}/libssp.la
%attr(755,root,root) %{_libdir}/libssp.so
%{_libdir}/libssp_nonshared.a
%{_libdir}/libssp_nonshared.la
%{_libdir}/gcc/*/*/libgcov.a
%{_libdir}/gcc/*/*/libgcc.a
%{_libdir}/gcc/*/*/libgcc_eh.a
%{_libdir}/gcc/*/*/specs
%{_libdir}/gcc/*/*/crt*.o
%attr(755,root,root) %{_libdir}/gcc/*/*/cc1
%attr(755,root,root) %{_libdir}/gcc/*/*/collect2

%{_libdir}/gcc/*/*/include/*.h
%{_libdir}/gcc/*/*/include/ssp/*.h

%files -n libgcc4
%defattr(644,root,root,755)
%attr(755,root,root) %{_slibdir}/libssp.so.*.*.*
%attr(755,root,root) %ghost %{_slibdir}/libssp.so.0
%attr(755,root,root) %{_slibdir}/libgcc_s.so.%{version}

%if %{with ada}
%files ada
%defattr(644,root,root,755)
%doc gcc/ada/ChangeLog
%attr(755,root,root) %{_bindir}/gnat*
%attr(755,root,root) %{_bindir}/gpr*
%attr(755,root,root) %{_libdir}/libgnarl*.so
%attr(755,root,root) %{_libdir}/libgnat*.so
%attr(755,root,root) %{_libdir}/gcc/*/*/gnat1
%{_libdir}/gcc/*/*/adainclude
%dir %{_libdir}/gcc/*/*/adalib
%{_libdir}/gcc/*/*/adalib/*.ali
%{_libdir}/gcc/*/*/adalib/g-trasym.o
%{_libdir}/gcc/*/*/adalib/libgccprefix.a
%ifarch %{ix86} %{x8664}
%{_libdir}/gcc/*/*/adalib/libgmem.a
%endif
%{_infodir}/gnat*

%files -n libgnat
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libgnarl*.so.1
%attr(755,root,root) %{_libdir}/libgnat*.so.1

%files -n libgnat-static
%defattr(644,root,root,755)
%{_libdir}/gcc/*/*/adalib/libgnarl.a
%{_libdir}/gcc/*/*/adalib/libgnat.a
%endif

%if %{with cxx}
%files c++
%defattr(644,root,root,755)
%doc gcc/cp/{ChangeLog,NEWS}
%attr(755,root,root) %{_bindir}/g++4
%attr(755,root,root) %{_bindir}/*-g++4
%attr(755,root,root) %{_bindir}/c++4
%attr(755,root,root) %{_bindir}/*-c++4
%attr(755,root,root) %{_libdir}/gcc/*/*/cc1plus
%{_libdir}/libsupc++.a
%{_libdir}/libsupc++.la
%{_mandir}/man1/g++4.1*

%files -n libstdc++4 -f libstdc++4.lang
%defattr(644,root,root,755)
%doc libstdc++-v3/{ChangeLog,README}
%attr(755,root,root) %{_libdir}/libstdc++.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libstdc++.so.6

%files -n libstdc++4-devel
%defattr(644,root,root,755)
%doc libstdc++-v3/docs/html
%dir %{_includedir}/c++
%{_includedir}/stdc++.h
%{_includedir}/c++/%{version}
%{_libdir}/libstdc++.la
%attr(755,root,root) %{_libdir}/libstdc++.so

%files -n libstdc++4-static
%defattr(644,root,root,755)
%{_libdir}/libstdc++.a
%endif

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: gcc4.spec,v $
Revision 1.438.2.24  2012/02/05 13:45:40  glen
- add gcc-ada

Revision 1.438.2.23  2012/01/28 15:46:55  glen
- skip_post_check_so libstdc++.so

Revision 1.438.2.22  2010/12/27 22:43:28  glen
- allow upgrading to g++ devel packages in builder; rel 10

Revision 1.438.2.21  2010/12/27 22:19:31  glen
- utf8

Revision 1.438.2.20  2008/02/15 03:44:28  glen
- do not let locale files collide with gcc package

Revision 1.438.2.19  2008-02-15 01:21:11  glen
- does not provide cpp (but cpp4); rel 8

Revision 1.438.2.18  2008-01-22 09:25:35  glen
- no %ghost for libgcc_s.so.1 symlink; rel 7

Revision 1.438.2.17  2008-01-21 17:48:48  glen
- package or remove files
- rename libgcc_s.so.1 so it would be symlink and can install with system libgcc

Revision 1.438.2.16  2007-11-19 07:29:08  glen
- rel 5

Revision 1.438.2.15  2007-11-16 08:10:58  glen
- add pr29826.patch; rel 4

Revision 1.438.2.14  2007/10/13 11:25:48  glen
- also disable --enable-secureplt; rel 3

Revision 1.438.2.13  2007/10/13 10:33:38  glen
- disable --with-long-double-128, we have glibc 2.3 in AC; rel 2

Revision 1.438.2.12  2007/05/30 19:00:59  qboosh
- explained

Revision 1.438.2.11  2007/05/30 08:46:15  glen
- sparc and ppc fail

Revision 1.438.2.10  2007/03/21 15:15:52  glen
- 4.1.2, builds

Revision 1.438.2.9  2007/03/18 12:18:44  glen
- BR gcc, ldconfig to libstdc++4

Revision 1.438.2.8  2007/03/17 00:04:40  glen
- correct x-libraries path

Revision 1.438.2.7  2007/03/16 23:20:50  glen
- fix deps

Revision 1.438.2.6  2007/03/16 23:10:04  glen
- strict require

Revision 1.438.2.5  2007/03/16 23:07:02  glen
- satisfy deps without suffix

Revision 1.438.2.4  2007/03/16 22:56:51  glen
- c++ package suffix

Revision 1.438.2.3  2007/03/16 22:48:50  glen
- cleanup unneccessary stuff
- packages now with c++

Revision 1.438.2.2  2007/03/16 21:26:44  glen
- truncate changelog

Revision 1.438.2.1  2007/03/16 20:22:13  glen
- prepare c++ building

Revision 1.438  2006/12/18 15:47:20  arekm
- disable multilib

Revision 1.437  2006/12/17 12:56:53  arekm
- seems to be working

Revision 1.436  2006/12/17 01:48:27  arekm
- additional gcc (4.1.1 release) for Ac
